diff --git a/Makefile.am b/Makefile.am
index c9b7ccd..9641e8a 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1,5 +1,7 @@
 ACLOCAL_AMFLAGS = -I m4
 
+AM_LDFLAGS = -no-undefined
+
 INCLUDES = $(all_includes) -I$(top_srcdir)/include
 SUBDIRS = include src src/vty src/codec src/gsm src/gb tests utils
 
@@ -54,3 +56,4 @@ DX_CLEAN = doc/{core,gsm,vty,codec}/{html,latex}/* doc/html.tar
 endif
 
 MOSTLYCLEANFILES = $(DX_CLEAN)
+
diff --git a/src/Makefile.am b/src/Makefile.am
index 081be96..e85f3e3 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -18,9 +18,9 @@ BUILT_SOURCES = crc8gen.c crc16gen.c crc32gen.c crc64gen.c
 
 if ENABLE_PLUGIN
 libosmocore_la_SOURCES += plugin.c
-libosmocore_la_LDFLAGS = -version-info $(LIBVERSION) $(LIBRARY_DL)
+libosmocore_la_LDFLAGS = -version-info $(LIBVERSION) $(LIBRARY_DL) -no-undefined
 else
-libosmocore_la_LDFLAGS = -version-info $(LIBVERSION)
+libosmocore_la_LDFLAGS = -version-info $(LIBVERSION) -no-undefined
 endif
 
 if ENABLE_TALLOC
diff --git a/src/codec/Makefile.am b/src/codec/Makefile.am
index 6110cbf..f4dec62 100644
--- a/src/codec/Makefile.am
+++ b/src/codec/Makefile.am
@@ -7,4 +7,4 @@ AM_CFLAGS = -Wall $(all_includes) -I$(top_srcdir)/include
 lib_LTLIBRARIES = libosmocodec.la
 
 libosmocodec_la_SOURCES = gsm610.c gsm620.c gsm660.c gsm690.c
-libosmocodec_la_LDFLAGS = -version-info $(LIBVERSION)
+libosmocodec_la_LDFLAGS = -version-info $(LIBVERSION) -no-undefined
diff --git a/src/gb/Makefile.am b/src/gb/Makefile.am
index 8b7473d..4b8dc96 100644
--- a/src/gb/Makefile.am
+++ b/src/gb/Makefile.am
@@ -10,7 +10,7 @@ noinst_HEADERS = common_vty.h
 if ENABLE_GB
 lib_LTLIBRARIES = libosmogb.la
 
-libosmogb_la_LDFLAGS = $(LTLDFLAGS_OSMOGB) -version-info $(LIBVERSION)
+libosmogb_la_LDFLAGS = $(LTLDFLAGS_OSMOGB) -version-info $(LIBVERSION) -no-undefined
 libosmogb_la_LIBADD = \
 		$(top_builddir)/src/libosmocore.la \
 		$(top_builddir)/src/vty/libosmovty.la \
diff --git a/src/gb/gprs_bssgp.c b/src/gb/gprs_bssgp.c
index e41c7ef..b5548c0 100644
--- a/src/gb/gprs_bssgp.c
+++ b/src/gb/gprs_bssgp.c
@@ -104,6 +104,7 @@ struct bssgp_bvc_ctx *btsctx_alloc(uint16_t bvci, uint16_t nsei)
 
 	return ctx;
 }
+int bssgp_prim_cb(struct osmo_prim_hdr *oph, void *ctx) { return -1; }
 
 /* Chapter 10.4.5: Flow Control BVC ACK */
 static int bssgp_tx_fc_bvc_ack(uint16_t nsei, uint8_t tag, uint16_t ns_bvci)
diff --git a/src/gsm/Makefile.am b/src/gsm/Makefile.am
index 6e2a785..59d4234 100644
--- a/src/gsm/Makefile.am
+++ b/src/gsm/Makefile.am
@@ -20,7 +20,7 @@ libosmogsm_la_SOURCES = a5.c rxlev_stat.c tlv_parser.c comp128.c gsm_utils.c \
 			milenage/aes-encblock.c milenage/aes-internal.c \
 			milenage/aes-internal-enc.c milenage/milenage.c gan.c
 
-libosmogsm_la_LDFLAGS = $(LTLDFLAGS_OSMOGSM) -version-info $(LIBVERSION)
+libosmogsm_la_LDFLAGS = $(LTLDFLAGS_OSMOGSM) -version-info $(LIBVERSION) -no-undefined
 libosmogsm_la_LIBADD = $(top_builddir)/src/libosmocore.la
 
 EXTRA_DIST = libosmogsm.map
diff --git a/src/vty/Makefile.am b/src/vty/Makefile.am
index 76d7f27..a6cfd6f 100644
--- a/src/vty/Makefile.am
+++ b/src/vty/Makefile.am
@@ -9,6 +9,6 @@ lib_LTLIBRARIES = libosmovty.la
 
 libosmovty_la_SOURCES = buffer.c command.c vty.c vector.c utils.c \
 			telnet_interface.c logging_vty.c
-libosmovty_la_LDFLAGS = -version-info $(LIBVERSION)
+libosmovty_la_LDFLAGS = -version-info $(LIBVERSION) -no-undefined
 libosmovty_la_LIBADD = $(top_builddir)/src/libosmocore.la
 endif
